#include "codeanalyzer.h"
#include "KBEditor.h"
#include <iostream>
using namespace std ;

CodeAnalyzer::CodeAnalyzer ( QObject *parent )
		: QObject ( parent )
{
}


CodeAnalyzer::~CodeAnalyzer()
{
}


/*!
    \fn CodeAnalyzer::analyze(const QString& text)
 */
int CodeAnalyzer::analyze ( KBEditor *ed )
{
	entryPoints_.clear() ;
	Kate::Document *doc  = ed->theDoc() ;


	for ( unsigned int i = 0 ; i < doc->numLines()-1 ; ++i )
	{
		int sz = doc->lineLength(i);
		QString line = doc->text ( i, 0, i ,  sz) ; // hum 
		if(line.startsWith(";<+") )
		{
			QString symbol , proto;
			unsigned int k ;
			for( k = 3 ; k < line.length() && line[k] != '>' ; ++k)
				symbol += line[k] ;
			// is prototype here ?
			if( ++k < line.length()) proto = line.right(line.length()-k) ;
			entryPoints_.push_back( EntryPointRecord (symbol,proto,i) ) ;
		}
	}
	return 0 ;
}

vector<EntryPointRecord>& CodeAnalyzer::entryPoints()
{
	return entryPoints_ ;
}
